// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package order_web

import (
	context "context"
	order "gitlab.com/adhocguru/fcp/apis/gen/order/v1/order"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// UserAccessServiceClient is the client API for UserAccessService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type UserAccessServiceClient interface {
	GetUserAccess(ctx context.Context, in *order.GetUserAccessRequest, opts ...grpc.CallOption) (*order.GetUserAccessResponse, error)
}

type userAccessServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewUserAccessServiceClient(cc grpc.ClientConnInterface) UserAccessServiceClient {
	return &userAccessServiceClient{cc}
}

func (c *userAccessServiceClient) GetUserAccess(ctx context.Context, in *order.GetUserAccessRequest, opts ...grpc.CallOption) (*order.GetUserAccessResponse, error) {
	out := new(order.GetUserAccessResponse)
	err := c.cc.Invoke(ctx, "/fcp.order.v1.order_web.UserAccessService/GetUserAccess", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// UserAccessServiceServer is the server API for UserAccessService service.
// All implementations must embed UnimplementedUserAccessServiceServer
// for forward compatibility
type UserAccessServiceServer interface {
	GetUserAccess(context.Context, *order.GetUserAccessRequest) (*order.GetUserAccessResponse, error)
	mustEmbedUnimplementedUserAccessServiceServer()
}

// UnimplementedUserAccessServiceServer must be embedded to have forward compatible implementations.
type UnimplementedUserAccessServiceServer struct {
}

func (UnimplementedUserAccessServiceServer) GetUserAccess(context.Context, *order.GetUserAccessRequest) (*order.GetUserAccessResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetUserAccess not implemented")
}
func (UnimplementedUserAccessServiceServer) mustEmbedUnimplementedUserAccessServiceServer() {}

// UnsafeUserAccessServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to UserAccessServiceServer will
// result in compilation errors.
type UnsafeUserAccessServiceServer interface {
	mustEmbedUnimplementedUserAccessServiceServer()
}

func RegisterUserAccessServiceServer(s grpc.ServiceRegistrar, srv UserAccessServiceServer) {
	s.RegisterService(&UserAccessService_ServiceDesc, srv)
}

func _UserAccessService_GetUserAccess_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(order.GetUserAccessRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UserAccessServiceServer).GetUserAccess(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/fcp.order.v1.order_web.UserAccessService/GetUserAccess",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UserAccessServiceServer).GetUserAccess(ctx, req.(*order.GetUserAccessRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// UserAccessService_ServiceDesc is the grpc.ServiceDesc for UserAccessService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var UserAccessService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "fcp.order.v1.order_web.UserAccessService",
	HandlerType: (*UserAccessServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetUserAccess",
			Handler:    _UserAccessService_GetUserAccess_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "v1/order_web/user_access_web.proto",
}
